function append() {
    var e = Array.prototype.slice.call(arguments), n = document.createDocumentFragment()
    e.forEach(function (e) {
        var t = e instanceof Node
        n.appendChild(t ? e : document.createTextNode(String(e)))
    })
    this.appendChild(n)
}

function prepend() {
    var e = Array.prototype.slice.call(arguments), n = document.createDocumentFragment()
    e.forEach(function (e) {
        var t = e instanceof Node
        n.appendChild(t ? e : document.createTextNode(String(e)))
    })
    this.insertBefore(n, this.firstChild)
}

function before() {
    var argArr = Array.prototype.slice.call(arguments),
        docFrag = document.createDocumentFragment()

    argArr.forEach(function (argItem) {
        var isNode = argItem instanceof Node
        docFrag.appendChild(isNode ? argItem : document.createTextNode(String(argItem)))
    })

    this.parentNode.insertBefore(docFrag, this)
}

function after() {
    var e = Array.prototype.slice.call(arguments), r = document.createDocumentFragment()
    e.forEach(function (e) {
        var t = e instanceof Node
        r.appendChild(t ? e : document.createTextNode(String(e)))
    })
    this.parentNode.insertBefore(r, this.nextSibling)
}

function remove() {
    null !== this.parentNode && this.parentNode.removeChild(this)
}

function replaceWith() {
    'use-strict' // For safari, and IE > 10
    var parent = this.parentNode, i = arguments.length, currentNode
    if (!parent) return
    if (!i) // if there are no arguments
        parent.removeChild(this)
    while (i--) { // i-- decrements i and returns the value of i before the decrement
        currentNode = arguments[i]
        if (typeof currentNode !== 'object') {
            currentNode = this.ownerDocument.createTextNode(currentNode)
        } else if (currentNode.parentNode) {
            currentNode.parentNode.removeChild(currentNode)
        }
        // the value of "i" below is after the decrement
        if (!i) // if currentNode is the first argument (currentNode === arguments[0])
            parent.replaceChild(currentNode, this)
        else // if currentNode isn't the first
            parent.insertBefore(currentNode, this.previousSibling)
    }
}

[Element.prototype, Document.prototype, DocumentFragment.prototype].forEach(function (e) {
    e.hasOwnProperty("append") || Object.defineProperty(e, "append", {
        configurable: !0,
        enumerable: !0,
        writable: !0,
        value: append
    })

    e.hasOwnProperty("prepend") || Object.defineProperty(e, "prepend", {
        configurable: !0,
        enumerable: !0,
        writable: !0,
        value: prepend
    })

    e.hasOwnProperty('before') || Object.defineProperty(e, 'before', {
        configurable: true,
        enumerable: true,
        writable: true,
        value: before
    })

    e.hasOwnProperty("after") || Object.defineProperty(e, "after", {
        configurable: !0,
        enumerable: !0,
        writable: !0,
        value: after
    })

    e.hasOwnProperty("remove") || Object.defineProperty(e, "remove", {
        configurable: !0,
        enumerable: !0,
        writable: !0,
        value: remove
    })

    if (!e.replaceWith) e.replaceWith = replaceWith
})
